create_obat/urls.py
from django.urls import path
from . import views

#url for app

app_name = 'create_obat'

urlpatterns = [
    path('',views.createObat, name='createObat'),
    path('daftarObat/', views.daftarObat, name='daftarObat'),
    path('updateObat/', views.updateObat, name='update'),
    path('deleteObat/', views.deleteObat, name='delete')
]

login/urls.py
from django.urls import path
from . import views

#url for app

app_name = 'login'

urlpatterns = [
    path('',views.fiturlogin, name='fiturlogin'),
    path('register/', views.register, name='register'),
    path('regisPasien/', views.regisPasien, name='pasien'),
    path('regisDoctor/', views.regisDoctor, name='doctor'),
    path('regisAdministrator/', views.regisAdm, name='admin'),
    path('logout/',views.logout,name='logout'),
    path('home/',views.home,name='home')
]

tugas_kelompok38/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('login.urls')),
    path('regisdokterrs/', include('reg_dokter_rs.urls')),
    path('layananpoli/', include('layanan_poli.urls')),
    path('transaksi/', include('transaksi.urls')),
    path('registerAdm/', include('regis_adm_to_RS.urls')),
    path('createResep/', include('create_resep.urls')),
    path('createObat/', include('create_obat.urls')),
    path('sesi_konsul/', include('sesi_konsultasi.urls')),
    path('rs_cabang/', include('rs_cabang.urls')),
]

create_obat/models.py
from django.db import models

# Create your models here.

create_obat/forms.py
from django import forms
from django.forms import widgets
from django.db import connection

class FormObat(forms.Form):
    kode =forms.CharField(
        label = 'Kode', max_length = 50, required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Kode Obat"}),
    )
    stok =forms.IntegerField(
        label = 'Stok',
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Stock Obat"}),
    )

    harga =forms.IntegerField(
        label = 'Harga', required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Harga Obat"}),
    )

    komposisi =forms.CharField(
        label = 'Komposisi', required= False,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm'}),
    )

    bentuk_sediaan =forms.CharField(
        label = 'Bentuk Sediaan', max_length = 50, required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Bentuk Obat"}),
    )

    merk_dagang =forms.CharField(
        label = 'Merk Dagang', max_length = 50, required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Merk Obat"}),
    )

    def save(self, commit=True):
        kode = self.cleaned_data.get('kode')
        stok = self.cleaned_data.get('stok')
        harga = self.cleaned_data.get('harga')
        komposisi = self.cleaned_data.get('komposisi')
        bentukSediaan = self.cleaned_data.get('bentuk_sediaan')
        merkDagang = self.cleaned_data.get('merk_dagang')

        with connection.cursor() as cursor:
            cursor.execute('INSERT into OBAT values (%s, %s, %s, %s, %s, %s)', [kode, stok, harga, komposisi, bentukSediaan,merkDagang])

    class Meta:
        # model = Obat
        fields= ('kode','stok','harga','komposisi','bentuk_sediaan','merk_dagang')

class FormUpdateObat(forms.Form):
    kode =forms.CharField(
        label = 'Kode', max_length = 50, required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'autocomplete':'off', 'readonly':'true'}),
    )
    stok =forms.IntegerField(
        label = 'Stok',
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Stock Obat"}),
    )

    harga =forms.IntegerField(
        label = 'Harga', required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Harga Obat"}),
    )

    komposisi =forms.CharField(
        label = 'Komposisi', required= False,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm'}),
    )

    bentuk_sediaan =forms.CharField(
        label = 'Bentuk Sediaan', max_length = 50, required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Bentuk Obat"}),
    )

    merk_dagang =forms.CharField(
        label = 'Merk Dagang', max_length = 50, required = True,
        widget = forms.TextInput(
            attrs = {'class' : 'form-control form-control-sm', 'placeholder' : "Masukkan Merk Obat"}),
    )
    
    def edit(self, commit=True, kode=None):
        stok2 = self.cleaned_data.get('stok')
        harga2 = self.cleaned_data.get('harga')
        komposisi2 = self.cleaned_data.get('komposisi')
        bentukSediaan2 = self.cleaned_data.get('bentuk_sediaan')
        merkDagang2 = self.cleaned_data.get('merk_dagang')

        with connection.cursor() as cursor:
            cursor.execute('UPDATE OBAT SET stok =%s,harga=%s,komposisi=%s,bentuk_sediaan=%s,merk_dagang=%s where kode =%s',
            [stok2, harga2, komposisi2, bentukSediaan2,merkDagang2,kode])



    class Meta:
        # model = Obat
        fields= ('kode','stok','harga','komposisi','bentuk_sediaan','merk_dagang')
      

create_obat/views.py
from django.shortcuts import render,redirect
from .forms import FormObat, FormUpdateObat
from django.http import HttpResponseRedirect
from django.db import connection

# Create your views here.
def createObat(request):
    form = FormObat
    if request.method=="POST":
        form= form(request.POST)
        if form.is_valid():
            form.save()
            return redirect('create_obat:daftarObat')            
            
    return render(request,'createObat.html', {'form' : form})


def daftarObat(request):
    aso = ''
    with connection.cursor() as obat:
        obat.execute("SELECT * FROM OBAT ORDER BY kode ASC")
        aso = obat.fetchall()
    
    return render(request, 'daftarObat.html',{'aso' : aso})

def updateObat(request):
    formUpdate = FormUpdateObat
    if request.method == 'POST':
        
        if request.POST.get('edit') == 'true':
            kodenya = request.POST.get('kodeobt')
          
            with connection.cursor() as obat:
                obat.execute('SELECT * from OBAT where kode =%s', [kodenya])
                obat = obat.fetchone()
                
                dct_of_obat = {
                    'kode' : obat[0],
                    'stok' : obat[1],
                    'harga' : obat[2],
                    'komposisi' : obat[3],
                    'bentuk_sediaan' : obat[4],
                    'merk_dagang' : obat[5],
                }

                formUpdate = formUpdate(dct_of_obat)

                return render(request, 'updateObat.html', {'formUpdate' : formUpdate, 'kode_obat' : obat[0]})
        else:
            formUpdate = formUpdate(request.POST)
            if formUpdate.is_valid():
                formUpdate.edit(kode = request.POST.get('kode_obat'))
                return redirect('create_obat:daftarObat')

    return render(request, 'updateObat.html', {'formUpdate' : formUpdate})


def deleteObat(request):
    if request.method == 'POST':
        kode = request.POST.get('kode')
        stok = request.POST.get('stok')
        harga = request.POST.get('harga')
        komposisi = request.POST.get('komposisi')
        bentukSediaan = request.POST.get('bentuk_sediaan')
        merkDagang = request.POST.get('merk_dagang')

        if kode:
            with connection.cursor() as admin:
                admin.execute('delete from obat where kode =%s and stok=%s and harga=%s and komposisi=%s and bentuk_sediaan=%s and merk_dagang=%s', [kode, stok, harga, komposisi, bentukSediaan, merkDagang])
    return redirect('create_obat:daftarObat')

create_obat/templates/createObat.html
<!DOCTYPE html>
{% extends "base.html" %}
{% load static %}
{% block content %}
<html lang="en"> 
<head>
 <meta charset="UTF-8">
 <meta name="viewport" content="width=device-width, initial-scale=1.0">
 <meta http-equiv="X-UA-Compatible" content="ie=edge">
 <title>Create Obat</title>
 <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
 <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
 <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/css/bootstrap-select.min.css">
 <script src="https://cdn.jsdelivr.net/npm/bootstrap-select@1.13.14/dist/js/bootstrap-select.min.js"></script>
 <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
 <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

</head>
<body>
  {% if request.session.role == 'admin' %}
    <h1>FORM PEMBUATAN OBAT</h1>
    <form method="POST" style="padding: 25px;">
    {% csrf_token %}
    {{form}}
    <button type="submit" class="btn btn-success">Submit</button>
    </form>
  {% endif %}
  </body>
</html>
{% endblock %}

create_obat/templates/daftarObat.html
<!DOCTYPE html>
{% extends "base.html" %}
{% load static %}
{% block content %}
<html lang="en"> 
<head>
 <meta charset="UTF-8">
 <meta name="viewport" content="width=device-width, initial-scale=1.0">
 <meta http-equiv="X-UA-Compatible" content="ie=edge">
 <title>Daftar Obat</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>

</head>
<body>
    <h1>Daftar  Obat</h1>
    {% if request.session.role == 'admin' %}
    <table class="table table-active table-hover">
        <tr>
            <th>Kode</th>
            <th>Stok</th>
            <th>Harga</th>
            <th>Komposisi</th>
            <th>Bentuk Sediaan</th>
            <th>Merk Dagang</th>
            <th>Action[admin]</th>
        </tr>

        {% for columnObat in aso %}
        <tr> 
            <td>{{ columnObat.0 }}</td>
            <td>{{ columnObat.1 }}</td>
            <td>{{ columnObat.2 }}</td>
            <td>{{ columnObat.3 }}</td>
            <td>{{ columnObat.4 }}</td>
            <td>{{ columnObat.5 }}</td>
            <td>
                <div class="d-flex flex-row">
                <form action="{% url 'create_obat:update' %}" method="POST" class="update">
                    {% csrf_token %}
                    <input type="hidden" name="kodeobt" value="{{ columnObat.0 }}">
                    <input type="hidden" name="edit" value="true" hidden>
                    <button type="submit" class="btn btn-success">Update</button>
                </form>
                <form action="{% url 'create_obat:delete' %}" method="POST" class="delete">
                    {% csrf_token %}
                    <input type="hidden" name="kode" value="{{ columnObat.0 }}">
                    <input type="hidden" name="stok" value="{{ columnObat.1 }}">
                    <input type="hidden" name="harga" value="{{ columnObat.2 }}">
                    <input type="hidden" name="komposisi" value="{{ columnObat.3 }}">
                    <input type="hidden" name="bentuk_sediaan" value="{{ columnObat.4 }}">
                    <input type="hidden" name="merk_dagang" value="{{ columnObat.5 }}">
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
                </div>
                <br>
            </td>
        </tr>
        {% endfor %}
    </table>
    {% else %}
    <table class="table table-active table-hover">
        <tr>
            <th>Kode</th>
            <th>Stok</th>
            <th>Harga</th>
            <th>Komposisi</th>
            <th>Bentuk Sediaan</th>
            <th>Merk Dagang</th>
        </tr>

        {% for columnObat in aso %}
        <tr> 
            <td>{{ columnObat.0 }}</td>
            <td>{{ columnObat.1 }}</td>
            <td>{{ columnObat.2 }}</td>
            <td>{{ columnObat.3 }}</td>
            <td>{{ columnObat.4 }}</td>
            <td>{{ columnObat.5 }}</td>
    
        </tr>
         {% endfor %}
    </table>
    {% endif %}
  </body>
</html>
{% endblock %}

create_obat/templates/updateObat.html
<!DOCTYPE html>
{% extends "base.html" %}
{% load static %}
{% block content %}
<html lang="en"> 
<head>
 <meta charset="UTF-8">
 <meta name="viewport" content="width=device-width, initial-scale=1.0">
 <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
    <script src="https://code.jquery.com/jquery-1.12.4.js"></script>
    <script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
    
</head>

<body>
  {% if request.session.role == 'admin' %}
    <div>
    <h1>FORM UPDATE OBAT</h1>

    <form method="POST" style="padding: 25px;">
        <div class="form-group">
          {{ formUpdate.kode.label }}
          {{ formUpdate.kode}}
          {% if formUpdate.kode.errors %}
            <strong style="color: red;">{{ formUpdate.kode.errors }}</strong>
          {% endif %}
        </div>
        <div class="form-group">
          {{ formUpdate.stok.label }}
          {{ formUpdate.stok }}
          {% if formUpdate.stok.errors %}
              <strong style="color: red;">{{ formUpdate.stok.errors }}</strong>
          {% endif %}
        </div>
        <div class="form-group">
          {{ formUpdate.harga.label }}
          {{ formUpdate.harga }}
          {% if formUpdate.harga.errors %}
              <strong style="color: red;">{{ formUpdate.harga.errors }}</strong>
          {% endif %}
        </div>
        <div class="form-group">
            {{ formUpdate.komposisi.label }}
            {{ formUpdate.komposisi}}
        </div>
        <div class="form-group">
            {{ formUpdate.bentuk_sediaan.label }}
            {{ formUpdate.bentuk_sediaan }}
            {% if formUpdate.bentuk_sediaan.errors %}
                <strong style="color: red;">{{ formUpdate.bentuk_sediaan.errors }}</strong>
            {% endif %}
        </div>
        <div class="form-group">
            {{ formUpdate.merk_dagang.label }}
            {{ formUpdate.merk_dagang }}
            {% if formUpdate.merk_dagang.errors %}
                <strong style="color: red;">{{ formUpdate.merk_dagang.errors }}</strong>
            {% endif %}
        </div>
        {% csrf_token %}
        <input type="hidden" name="kode_obat" value="{{ kode_obat }}">
        <button type="submit" class="btn btn-success" style="margin-top: 15px;">Update</button>
  </form>
</div>
{% endif %}
</body>
</html>
{% endblock %}